/**
 * @name string-range-expander
 * @fileoverview Expands string index ranges within whitespace boundaries until letters are met
 * @version 4.0.6
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-range-expander/}
 */

function f(e){if(e==null||typeof e!="object")return!1;let a=Object.getPrototypeOf(e);return a!==null&&a!==Object.prototype&&Object.getPrototypeOf(a)!==null?!1:!(Symbol.iterator in e)&&!(Symbol.toStringTag in e)}function l(e){return typeof e=="string"}function d(e){return Number.isSafeInteger(e)&&e>=0}var h="4.0.6";var y=h,T={str:"",from:0,to:0,ifLeftSideIncludesThisThenCropTightly:"",ifLeftSideIncludesThisCropItToo:"",ifRightSideIncludesThisThenCropTightly:"",ifRightSideIncludesThisCropItToo:"",extendToOneSide:!1,wipeAllWhitespaceOnLeft:!1,wipeAllWhitespaceOnRight:!1,addSingleSpaceToPreventAccidentalConcatenation:!1};function x(e){let a=/^[0-9a-zA-Z]+$/;function o(n){return l(n)&&!n.trim()}if(f(e)){if(!Object.keys(e).length)throw new Error("string-range-expander: [THROW_ID_02] Input must be a plain object but it was given as a plain object without any keys.")}else{let n;throw e===void 0?n="but it is missing completely.":e===null?n="but it was given as null.":n=`but it was given as ${typeof e}, equal to:
${JSON.stringify(e,null,4)}.`,new Error(`string-range-expander: [THROW_ID_01] Input must be a plain object ${n}`)}if(!d(e.from))throw new Error(`string-range-expander: [THROW_ID_03] The input's "from" value resolvedOpts.from, is not a number! Currently it's given as ${typeof e.from}, equal to ${JSON.stringify(e.from,null,0)}`);if(!d(e.to))throw new Error(`string-range-expander: [THROW_ID_04] The input's "to" value resolvedOpts.to, is not a number! Currently it's given as ${typeof e.to}, equal to ${JSON.stringify(e.to,null,0)}`);if(e?.str&&!e.str[e.from]&&e.from!==e.to)throw new Error(`string-range-expander: [THROW_ID_05] The given input string resolvedOpts.str ("${e.str}") must contain the character at index "from" ("${e.from}")`);if(e?.str&&!e.str[e.to-1])throw new Error(`string-range-expander: [THROW_ID_06] The given input string, resolvedOpts.str ("${e.str}") must contain the character at index before "to" ("${e.to-1}")`);if(e.from>e.to)throw new Error(`string-range-expander: [THROW_ID_07] The given "from" index, "${e.from}" is greater than "to" index, "${e.to}". That's wrong!`);if(e.extendToOneSide===null||l(e.extendToOneSide)&&e.extendToOneSide!=="left"&&e.extendToOneSide!=="right"||!l(e.extendToOneSide)&&e.extendToOneSide!==void 0&&e.extendToOneSide)throw new Error(`string-range-expander: [THROW_ID_08] The resolvedOpts.extendToOneSide value is not recognisable! It's set to: "${e.extendToOneSide}" (${typeof e.extendToOneSide}). It has to be either Boolean "false" or strings "left" or "right"`);let i={...T,...e};if(Array.isArray(i.ifLeftSideIncludesThisThenCropTightly)){let n,u;if(i.ifLeftSideIncludesThisThenCropTightly.every((c,p)=>l(c)?!0:(n=p,u=c,!1)))i.ifLeftSideIncludesThisThenCropTightly=i.ifLeftSideIncludesThisThenCropTightly.join("");else throw new Error(`string-range-expander: [THROW_ID_09] The resolvedOpts.ifLeftSideIncludesThisThenCropTightly was set to an array:
${JSON.stringify(i.ifLeftSideIncludesThisThenCropTightly,null,4)}. Now, that array contains not only string elements. For example, an element at index ${n} is of a type ${typeof u} (equal to ${JSON.stringify(u,null,0)}).`)}let t=i.str,r=i.from,s=i.to;if(i.extendToOneSide!=="right"&&(o(t[r-1])&&(o(t[r-2])||i.ifLeftSideIncludesThisCropItToo.includes(t[r-2]))||t[r-1]&&i.ifLeftSideIncludesThisCropItToo.includes(t[r-1])||i.wipeAllWhitespaceOnLeft&&o(t[r-1]))){for(let n=r;n--;)if(!i.ifLeftSideIncludesThisCropItToo.includes(t[n])){if(t[n].trim()){i.wipeAllWhitespaceOnLeft||i.ifLeftSideIncludesThisCropItToo.includes(t[n+1])?r=n+1:r=n+2;break}else if(n===0){i.wipeAllWhitespaceOnLeft?r=0:r=1;break}}}if(i.extendToOneSide!=="left"&&(o(t[s])&&(i.wipeAllWhitespaceOnRight||o(t[s+1]))||i.ifRightSideIncludesThisCropItToo.includes(t[s]))){for(let n=s,u=t.length;n<u;n++)if(!i.ifRightSideIncludesThisCropItToo.includes(t[n])&&t[n]?.trim()){i.wipeAllWhitespaceOnRight||i.ifRightSideIncludesThisCropItToo.includes(t[n-1])?s=n:s=n-1;break}}return(i.extendToOneSide!=="right"&&l(i.ifLeftSideIncludesThisThenCropTightly)&&i.ifLeftSideIncludesThisThenCropTightly&&(t[r-2]&&i.ifLeftSideIncludesThisThenCropTightly.includes(t[r-2])||t[r-1]&&i.ifLeftSideIncludesThisThenCropTightly.includes(t[r-1]))||i.extendToOneSide!=="left"&&l(i.ifRightSideIncludesThisThenCropTightly)&&i.ifRightSideIncludesThisThenCropTightly&&(t[s+1]&&i.ifRightSideIncludesThisThenCropTightly.includes(t[s+1])||t[s]&&i.ifRightSideIncludesThisThenCropTightly.includes(t[s])))&&(i.extendToOneSide!=="right"&&o(t[r-1])&&!i.wipeAllWhitespaceOnLeft&&(r-=1),i.extendToOneSide!=="left"&&o(t[s])&&!i.wipeAllWhitespaceOnRight&&(s+=1)),i.addSingleSpaceToPreventAccidentalConcatenation&&t[r-1]&&t[r-1].trim()&&t[s]&&t[s].trim()&&(!i.ifLeftSideIncludesThisThenCropTightly&&!i.ifRightSideIncludesThisThenCropTightly||!((!i.ifLeftSideIncludesThisThenCropTightly||i.ifLeftSideIncludesThisThenCropTightly.includes(t[r-1]))&&(!i.ifRightSideIncludesThisThenCropTightly||t[s]&&i.ifRightSideIncludesThisThenCropTightly.includes(t[s]))))&&(a.test(t[r-1])||a.test(t[s]))?[r,s," "]:[r,s]}export{T as defaults,x as expander,y as version};
/**
 * @name codsen-utils
 * @fileoverview Various utility functions
 * @version 1.3.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/codsen-utils/}
 */
