/**
 * @name string-range-expander
 * @fileoverview Expands string index ranges within whitespace boundaries until letters are met
 * @version 4.0.6
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-range-expander/}
 */

"use strict";var stringRangeExpander=(()=>{var d=Object.defineProperty;var x=Object.getOwnPropertyDescriptor;var O=Object.getOwnPropertyNames,g=Object.getOwnPropertySymbols;var m=Object.prototype.hasOwnProperty,C=Object.prototype.propertyIsEnumerable;var T=(e,t,s)=>t in e?d(e,t,{enumerable:!0,configurable:!0,writable:!0,value:s}):e[t]=s,c=(e,t)=>{for(var s in t||(t={}))m.call(t,s)&&T(e,s,t[s]);if(g)for(var s of g(t))C.call(t,s)&&T(e,s,t[s]);return e};var I=(e,t)=>{for(var s in t)d(e,s,{get:t[s],enumerable:!0})},w=(e,t,s,i)=>{if(t&&typeof t=="object"||typeof t=="function")for(let n of O(t))!m.call(e,n)&&n!==s&&d(e,n,{get:()=>t[n],enumerable:!(i=x(t,n))||i.enumerable});return e};var A=e=>w(d({},"__esModule",{value:!0}),e);var L={};I(L,{defaults:()=>$,expander:()=>D,version:()=>v});function b(e){if(e==null||typeof e!="object")return!1;let t=Object.getPrototypeOf(e);return t!==null&&t!==Object.prototype&&Object.getPrototypeOf(t)!==null?!1:!(Symbol.iterator in e)&&!(Symbol.toStringTag in e)}function a(e){return typeof e=="string"}function f(e){return Number.isSafeInteger(e)&&e>=0}var S="4.0.6";var v=S,$={str:"",from:0,to:0,ifLeftSideIncludesThisThenCropTightly:"",ifLeftSideIncludesThisCropItToo:"",ifRightSideIncludesThisThenCropTightly:"",ifRightSideIncludesThisCropItToo:"",extendToOneSide:!1,wipeAllWhitespaceOnLeft:!1,wipeAllWhitespaceOnRight:!1,addSingleSpaceToPreventAccidentalConcatenation:!1};function D(e){var h;let t=/^[0-9a-zA-Z]+$/;function s(r){return a(r)&&!r.trim()}if(b(e)){if(!Object.keys(e).length)throw new Error("string-range-expander: [THROW_ID_02] Input must be a plain object but it was given as a plain object without any keys.")}else{let r;throw e===void 0?r="but it is missing completely.":e===null?r="but it was given as null.":r=`but it was given as ${typeof e}, equal to:
${JSON.stringify(e,null,4)}.`,new Error(`string-range-expander: [THROW_ID_01] Input must be a plain object ${r}`)}if(!f(e.from))throw new Error(`string-range-expander: [THROW_ID_03] The input's "from" value resolvedOpts.from, is not a number! Currently it's given as ${typeof e.from}, equal to ${JSON.stringify(e.from,null,0)}`);if(!f(e.to))throw new Error(`string-range-expander: [THROW_ID_04] The input's "to" value resolvedOpts.to, is not a number! Currently it's given as ${typeof e.to}, equal to ${JSON.stringify(e.to,null,0)}`);if(e!=null&&e.str&&!e.str[e.from]&&e.from!==e.to)throw new Error(`string-range-expander: [THROW_ID_05] The given input string resolvedOpts.str ("${e.str}") must contain the character at index "from" ("${e.from}")`);if(e!=null&&e.str&&!e.str[e.to-1])throw new Error(`string-range-expander: [THROW_ID_06] The given input string, resolvedOpts.str ("${e.str}") must contain the character at index before "to" ("${e.to-1}")`);if(e.from>e.to)throw new Error(`string-range-expander: [THROW_ID_07] The given "from" index, "${e.from}" is greater than "to" index, "${e.to}". That's wrong!`);if(e.extendToOneSide===null||a(e.extendToOneSide)&&e.extendToOneSide!=="left"&&e.extendToOneSide!=="right"||!a(e.extendToOneSide)&&e.extendToOneSide!==void 0&&e.extendToOneSide)throw new Error(`string-range-expander: [THROW_ID_08] The resolvedOpts.extendToOneSide value is not recognisable! It's set to: "${e.extendToOneSide}" (${typeof e.extendToOneSide}). It has to be either Boolean "false" or strings "left" or "right"`);let i=c(c({},$),e);if(Array.isArray(i.ifLeftSideIncludesThisThenCropTightly)){let r,u;if(i.ifLeftSideIncludesThisThenCropTightly.every((p,y)=>a(p)?!0:(r=y,u=p,!1)))i.ifLeftSideIncludesThisThenCropTightly=i.ifLeftSideIncludesThisThenCropTightly.join("");else throw new Error(`string-range-expander: [THROW_ID_09] The resolvedOpts.ifLeftSideIncludesThisThenCropTightly was set to an array:
${JSON.stringify(i.ifLeftSideIncludesThisThenCropTightly,null,4)}. Now, that array contains not only string elements. For example, an element at index ${r} is of a type ${typeof u} (equal to ${JSON.stringify(u,null,0)}).`)}let n=i.str,o=i.from,l=i.to;if(i.extendToOneSide!=="right"&&(s(n[o-1])&&(s(n[o-2])||i.ifLeftSideIncludesThisCropItToo.includes(n[o-2]))||n[o-1]&&i.ifLeftSideIncludesThisCropItToo.includes(n[o-1])||i.wipeAllWhitespaceOnLeft&&s(n[o-1]))){for(let r=o;r--;)if(!i.ifLeftSideIncludesThisCropItToo.includes(n[r])){if(n[r].trim()){i.wipeAllWhitespaceOnLeft||i.ifLeftSideIncludesThisCropItToo.includes(n[r+1])?o=r+1:o=r+2;break}else if(r===0){i.wipeAllWhitespaceOnLeft?o=0:o=1;break}}}if(i.extendToOneSide!=="left"&&(s(n[l])&&(i.wipeAllWhitespaceOnRight||s(n[l+1]))||i.ifRightSideIncludesThisCropItToo.includes(n[l]))){for(let r=l,u=n.length;r<u;r++)if(!i.ifRightSideIncludesThisCropItToo.includes(n[r])&&((h=n[r])!=null&&h.trim())){i.wipeAllWhitespaceOnRight||i.ifRightSideIncludesThisCropItToo.includes(n[r-1])?l=r:l=r-1;break}}return(i.extendToOneSide!=="right"&&a(i.ifLeftSideIncludesThisThenCropTightly)&&i.ifLeftSideIncludesThisThenCropTightly&&(n[o-2]&&i.ifLeftSideIncludesThisThenCropTightly.includes(n[o-2])||n[o-1]&&i.ifLeftSideIncludesThisThenCropTightly.includes(n[o-1]))||i.extendToOneSide!=="left"&&a(i.ifRightSideIncludesThisThenCropTightly)&&i.ifRightSideIncludesThisThenCropTightly&&(n[l+1]&&i.ifRightSideIncludesThisThenCropTightly.includes(n[l+1])||n[l]&&i.ifRightSideIncludesThisThenCropTightly.includes(n[l])))&&(i.extendToOneSide!=="right"&&s(n[o-1])&&!i.wipeAllWhitespaceOnLeft&&(o-=1),i.extendToOneSide!=="left"&&s(n[l])&&!i.wipeAllWhitespaceOnRight&&(l+=1)),i.addSingleSpaceToPreventAccidentalConcatenation&&n[o-1]&&n[o-1].trim()&&n[l]&&n[l].trim()&&(!i.ifLeftSideIncludesThisThenCropTightly&&!i.ifRightSideIncludesThisThenCropTightly||!((!i.ifLeftSideIncludesThisThenCropTightly||i.ifLeftSideIncludesThisThenCropTightly.includes(n[o-1]))&&(!i.ifRightSideIncludesThisThenCropTightly||n[l]&&i.ifRightSideIncludesThisThenCropTightly.includes(n[l]))))&&(t.test(n[o-1])||t.test(n[l]))?[o,l," "]:[o,l]}return A(L);})();
/**
 * @name codsen-utils
 * @fileoverview Various utility functions
 * @version 1.3.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/codsen-utils/}
 */
